unit UnifyArc;

//***************************************************************************
//
//      A[JCo[̋ʐ錾
//
//***************************************************************************

{$DEBUGINFO OFF}

interface

uses
	Windows, SysUtils, SysConst;

//UnZip32.h
const
	FNAME_MAX32 = 512;
	//FNAME_MAX   = 128;

//UnGca32.h
type
	ULHA_INT64 = Int64;

//tar32api.h
type
	Ptime_t = ^time_t;
	time_t = LongInt;

//UnZip32.h
const
	COMMENT_MAX = 2048;

//UnZip32.h
type
	HARCHIVE = HGLOBAL;
	HARC = HGLOBAL;

	PINDIVIDUALINFO = ^TINDIVIDUALINFO;
	TINDIVIDUALINFO = packed record
		dwOriginalSize:   DWORD; //t@C̃TCYB
		dwCompressedSize: DWORD; //k̃TCYB
		dwCRC:            DWORD; //i[t@C̃`FbNT/CRC
		uFlag:            UINT;  //𓀂eXg̏
		uOSType:          UINT;  //̃t@C̍쐬ɎgꂽnrB
		wRatio:           WORD;  //kip[~)
		wDate:            WORD;	 //i[t@C̓tB
		wTime:            WORD;  //i[t@C̎B
		szFileName:       Array[0..FNAME_MAX32] of AnsiChar; //A[JCut@C
		dummy1:           Array[0..2] of Byte;
		szAttribute:      Array[0..7] of AnsiChar; //i[t@C̑B
		szMode:           Array[0..7] of AnsiChar; //i[t@C̊i[[hB
	end;

	PEXTRACTINGINFO = ^TEXTRACTINGINFO;
	TEXTRACTINGINFO = packed record
		dwFileSize:       DWORD; //i[t@C̃TCY
		dwWriteSize:      DWORD; //𓀂ď񂾃TCY
		szSourceFileName: Array[0..FNAME_MAX32] of Char; //si[t@C
		dummy1:           Array[0..2] of Char;
		szDestFileName:   Array[0..FNAME_MAX32] of Char; //ۂɏ܂pX
		dummy:            Array[0..2] of Char;
	end;

	PEXTRACTINGINFOEX = ^TEXTRACTINGINFOEX;
	TEXTRACTINGINFOEX = packed record
		exinfo:           TEXTRACTINGINFO;
		dwCompressedSize: DWORD; //k̃TCYB
		dwCRC:            DWORD; //i[t@C̃`FbNT/CRC
		uOSType:          UINT;  //̃t@C̍쐬Ɏgꂽnr
		wRatio:           WORD;  //kip[~)
		wDate:            WORD;  //i[t@C̓tB
		wTime:            WORD;  //i[t@C̎B
		szAttribute:      Array[0..7] of Char; //i[t@C̑B
		szMode:           Array[0..7] of Char; //i[t@C̊i[[hB
	end;

//UnGca32.h
const
	CHECKARCHIVE_RAPID    =  0; //ȈՌ^ij
	CHECKARCHIVE_BASIC    =  1; //W^iwb_[̂݁j
	CHECKARCHIVE_FULLCRC  =  2; //S^ibqb̃`FbN܂ށj
	CHECKARCHIVE_RECOVERY =  4; //jwb_ǂݔ΂ď
	CHECKARCHIVE_SFX		  =  8; //SFX ǂԂ
	CHECKARCHIVE_ALL		  = 16; //t@C̍Ō܂Ō

//UnZip32.h
const
	UNPACK_CONFIG_MODE = 1; //𓀁ijñR}h
	PACK_CONFIG_MODE   = 2; //ki쐬jñR}h

//7-zip32.h
const
	ISARC_FUNCTION_START       = 0;
	ISARC                      = 0;
	ISARC_GET_VERSION          = 1;
	ISARC_GET_CURSOR_INTERVAL  = 2;
	ISARC_SET_CURSOR_INTERVAL  = 3;
	ISARC_GET_BACK_GROUND_MODE = 4;
	ISARC_SET_BACK_GROUND_MODE = 5;
	ISARC_GET_CURSOR_MODE      = 6;
	ISARC_SET_CURSOR_MODE      = 7;
	ISARC_GET_RUNNING          = 8;

	ISARC_CHECK_ARCHIVE       = 16;
	ISARC_CONFIG_DIALOG       = 17;
	ISARC_GET_FILE_COUNT      = 18;
	ISARC_QUERY_FUNCTION_LIST = 19;
	ISARC_HOUT                =	20;
	ISARC_STRUCTOUT           =	21;
	ISARC_GET_ARC_FILE_INFO   = 22;

	ISARC_OPEN_ARCHIVE      = 23;
	ISARC_CLOSE_ARCHIVE     = 24;
	ISARC_FIND_FIRST        = 25;
	ISARC_FIND_NEXT         = 26;
	ISARC_EXTRACT           = 27;
	ISARC_ADD               = 28;
	ISARC_MOVE              = 29;
	ISARC_DELETE            = 30;
	ISARC_SETOWNERWINDOW    = 31;
	ISARC_CLEAROWNERWINDOW  = 32;
	ISARC_SETOWNERWINDOWEX  = 33;
	ISARC_KILLOWNERWINDOWEX = 34;

	ISARC_GET_ARC_FILE_NAME       = 40;
	ISARC_GET_ARC_FILE_SIZE       = 41;
	ISARC_GET_ARC_ORIGINAL_SIZE   = 42;
	ISARC_GET_ARC_COMPRESSED_SIZE = 43;
	ISARC_GET_ARC_RATIO           = 44;
	ISARC_GET_ARC_DATE            = 45;
	ISARC_GET_ARC_TIME            = 46;
	ISARC_GET_ARC_OS_TYPE         = 47;
	ISARC_GET_ARC_IS_SFX_FILE     = 48;
	ISARC_GET_ARC_CREATE_TIME_EX  = 50;
	ISARC_GET_ARC_ACCESS_TIME_EX  = 51;
	ISARC_GET_ARC_CREATE_TIME_EX2 = 52;
	ISARC_GET_FILE_NAME           = 57;
	ISARC_GET_ORIGINAL_SIZE       = 58;
	ISARC_GET_COMPRESSED_SIZE     = 59;
	ISARC_GET_RATIO               = 60;
	ISARC_GET_DATE                = 61;
	ISARC_GET_TIME                = 62;
	ISARC_GET_CRC                 = 63;
	ISARC_GET_ATTRIBUTE           = 64;
	ISARC_GET_OS_TYPE             = 65;
	ISARC_GET_METHOD              = 66;
	ISARC_GET_WRITE_TIME          = 67;
	ISARC_GET_CREATE_TIME         = 68;
	ISARC_GET_ACCESS_TIME         = 69;
	ISARC_GET_WRITE_TIME_EX       = 70;
	ISARC_GET_CREATE_TIME_EX      = 71;
	ISARC_GET_ACCESS_TIME_EX      = 72;
	ISARC_SET_ENUM_MEMBERS_PROC   = 80;
	ISARC_CLEAR_ENUM_MEMBERS_PROC = 81;
	ISARC_GET_ARC_FILE_SIZE_EX		   = 82; //* SevenZipGetArcFileSizeEx */
	ISARC_GET_ARC_ORIGINAL_SIZE_EX   = 83; //* SevenZipArcOriginalSizeEx */
	ISARC_GET_ARC_COMPRESSED_SIZE_EX = 84; //* SevenZipGetArcCompressedSizeEx */
	ISARC_GET_ORIGINAL_SIZE_EX	     = 85; //* SevenZipGetOriginalSizeEx */
	ISARC_GET_COMPRESSED_SIZE_EX     = 86; //* SevenZipGetCompressedSizeEx */
	ISARC_SETOWNERWINDOWEX64	       = 87; //* SevenZipSetOwnerWindowEx64 */
	ISARC_KILLOWNERWINDOWEX64	       = 88; //* SevenZipKillOwnerWindowEx64 */
	ISARC_SET_ENUM_MEMBERS_PROC64	   = 89; //* SevenZipSetEnumMembersProc64 */
	ISARC_CLEAR_ENUM_MEMBERS_PROC64  = 90; //* SevenZipClearEnumMembersProc64 */
	ISARC_OPEN_ARCHIVE2			         = 91; //* SevenZipOpenArchive2 */
	ISARC_GET_ARC_READ_SIZE		       = 92; //* SevenZipGetArcReadSize */
	ISARC_GET_ARC_READ_SIZE_EX       = 93; //* SevenZipGetArcReadSizeEx*/

	ISARC_FUNCTION_END	=	ISARC_GET_ARC_READ_SIZE_EX;

//UnZip32.h
//i[Ăt@C̏̎擾B

const
	WM_ARCEXTRACT = 'wm_arcextract';

	ARCEXTRACT_BEGIN     = 0; //Yt@C̏̊Jn
	ARCEXTRACT_INPROCESS = 1; //Yt@C̓WJ
	ARCEXTRACT_END       = 2; //IA֘AJ
	ARCEXTRACT_OPEN      = 3; //Yɂ̏̊Jn
	ARCEXTRACT_COPY      = 4; //[Nt@C̏߂

type
	PARCHIVERPROC = function(Wnd: HWND; uMsg: UINT; nState: UINT; lpEis: PEXTRACTINGINFOEX): BOOL; stdcall;

//Ungca32.h
const
	M_INIT_FILE_USE         = $00000001;
	M_REGARDLESS_INIT_FILE  = $00000002;
	M_NO_BACKGROUND_MODE    = $00000004; //Unlha32.h
	M_NOT_USE_TIME_STAMP    = $00000008;
	M_EXTRACT_REPLACE_FILE  = $00000010;
	M_EXTRACT_NEW_FILE      = $00000020;
	M_EXTRACT_UPDATE_FILE   = $00000040;
	M_CHECK_ALL_PATH        = $00000100;
	M_CHECK_FILENAME_ONLY   = $00000200;
	M_USE_DRIVE_LETTER      = $00001000;
	M_NOT_USE_DRIVE_LETTER  = $00002000;
	M_INQUIRE_DIRECTORY     = $00004000;
	M_NOT_INQUIRE_DIRECTORY = $00008000;
	M_INQUIRE_WRITE         = $00010000;
	M_NOT_INQUIRE_WRITE     = $00020000;
	M_REGARD_E_COMMAND      = $00100000;
	M_REGARD_X_COMMAND      = $00200000;
	M_ERROR_MESSAGE_ON      = $00400000;
	M_ERROR_MESSAGE_OFF     = $00800000;
	M_BAR_WINDOW_ON         = $01000000;
	M_BAR_WINDOW_OFF        = $02000000;
	M_RECOVERY_ON           = $08000000; //jwb_̓ǂݔ΂

	M_MAKE_INDEX_FILE		    = $10000000;
	M_NOT_MAKE_INDEX_FILE	  = $20000000;

	EXTRACT_FOUND_FILE = $40000000;
	EXTRACT_NAMED_FILE = $80000000;

//UnZip32.h
const
	FA_RDONLY    = $01; // Read only attribute
	FA_HIDDEN    = $02; // Hidden file
	FA_SYSTEM    = $04; // System file
	FA_LABEL     = $08; // Volume label
	FA_DIREC     = $10; // Directory
	FA_ARCH      = $20; // Archive
	FA_ENCRYPTED = $40; // Encripted by password

//Unlha32.h
const
	SFXFLAG_AUTO			    = $0001;
	SFXFLAG_OVERWRITE		  = $0002;
	SFXFLAG_CHECKCRC		  = $0004;
	SFXFLAG_CHECKTIME		  = $0008;
	SFXFLAG_ATTRIBUTE		  = $0010;
	SFXFLAG_NO_AUTO			  = $0100;
	SFXFLAG_NO_OVERWRITE	= $0200;
	SFXFLAG_NO_CHECKCRC		= $0400;
	SFXFLAG_NO_CHECKTIME	= $0800;
	SFXFLAG_NO_ATTRIBUTE	= $1000;

//7-zip32.h
const
	ERROR_START = $8000;
	// WARNING
	ERROR_DISK_SPACE    = $8005;
	ERROR_READ_ONLY     = $8006;
	ERROR_USER_SKIP     = $8007;
	ERROR_UNKNOWN_TYPE  = $8008;
	ERROR_METHOD        = $8009;
	ERROR_PASSWORD_FILE = $800A;
	ERROR_VERSION       = $800B;
	ERROR_FILE_CRC      = $800C;
	ERROR_FILE_OPEN     = $800D;
	ERROR_MORE_FRESH    = $800E;
	ERROR_NOT_EXIST     = $800F;
	ERROR_ALREADY_EXIST     = $8010;
	ERROR_TOO_MANY_FILES    = $8011;
	// ERROR
	ERROR_MAKEDIRECTORY     = $8012;
	ERROR_CANNOT_WRITE      = $8013;
	ERROR_HUFFMAN_CODE      = $8014;
	ERROR_COMMENT_HEADER    = $8015;
	ERROR_HEADER_CRC        = $8016;
	ERROR_HEADER_BROKEN     = $8017;
	ERROR_ARCHIVE_FILE_OPEN = $8018;
	ERROR_NOT_ARC_FILE      = $8019;
	ERROR_CANNOT_READ       = $801A;
	ERROR_FILE_STYLE        = $801B;
	ERROR_COMMAND_NAME      = $801C;
	ERROR_MORE_HEAP_MEMORY  = $801D;
	ERROR_ENOUGH_MEMORY     = $801E;
	ERROR_ALREADY_RUNNING   = $801F;
	ERROR_USER_CANCEL       = $8020;
	ERROR_HARC_ISNOT_OPENED = $8021;
	ERROR_NOT_SEARCH_MODE   = $8022;
	ERROR_NOT_SUPPORT       = $8023;
	ERROR_TIME_STAMP        = $8024;
	ERROR_TMP_OPEN          = $8025;
	ERROR_LONG_FILE_NAME    = $8026;
	ERROR_ARC_READ_ONLY     = $8027;
	ERROR_SAME_NAME_FILE    = $8028;
	ERROR_NOT_FIND_ARC_FILE = $8029;
	ERROR_RESPONSE_READ     = $802A;
	ERROR_NOT_FILENAME      = $802B;
	ERROR_TMP_COPY		=	$802C;
	ERROR_EOF			=	$802D;
	ERROR_ADD_TO_LARC	=	$802E;
	ERROR_TMP_BACK_SPACE=	$802F;
	ERROR_SHARING		=	$8030;
	ERROR_NOT_FIND_FILE	=	$8031;
	ERROR_LOG_FILE		=	$8032;
	ERROR_NO_DEVICE		=	$8033;
	ERROR_GET_ATTRIBUTES=	$8034;
	ERROR_SET_ATTRIBUTES=	$8035;
	ERROR_GET_INFORMATION=	$8036;
	ERROR_GET_POINT		=	$8037;
	ERROR_SET_POINT		=	$8038;
	ERROR_CONVERT_TIME	=	$8039;
	ERROR_GET_TIME		=	$803a;
	ERROR_SET_TIME		=	$803b;
	ERROR_CLOSE_FILE	=	$803c;
	ERROR_HEAP_MEMORY	=	$803d;
	ERROR_HANDLE = $803e;
	ERROR_TIME_STAMP_RANGE = $803f;
	ERROR_MAKE_ARCHIVE =	$8040;
	ERROR_NOT_CONFIRM_NAME	=$8041;
	ERROR_UNEXPECTED_EOF	=$8042;
	ERROR_INVALID_END_MARK =	$8043;
	ERROR_INVOLVED_LZH	=	$8044;
	ERROR_NO_END_MARK		=$8045;
	ERROR_HDR_INVALID_SIZE=	$8046;
	ERROR_UNKNOWN_LEVEL=		$8047;
	ERROR_BROKEN_DATA		=$8048;

	ERROR_END = ERROR_BROKEN_DATA;

//#### Delphi ####

type
	EArchiverError = class(Exception);
	TArchiverErrorClass = Class of EArchiverError;

resourcestring
	SNoExistProc = '%sɂ%s API݂͑܂.';
	SFaultLoad   = '%s̓ǂݍ݂Ɏs܂.';

implementation

end.
