unit UnLha32;

//*******************************************************************
//
//	UNLHA32.DLL C|[gjbg
//
(* UNLHA32.H, Micco, Aug.2,1998
**
** LH 2.02a
** Copyright (c) 1988-90 by Haruyasu Yoshizaki  All rights reserved.
**
** Win/WinNT-SFX
** Copyright (c) 1995-96 by mH        All rights reserved.
**
** UNLHA32.DLL
** Copyright (c) 1995-98 by Micco     All rights reserved.
*)
//*******************************************************************

interface

uses
	Windows, Messages, SysUtils,
	UnifyArc;

type
	PUNLHA_ENUM_MEMBER_INFO = ^TUNLHA_ENUM_MEMBER_INFO;
	TUNLHA_ENUM_MEMBER_INFO = packed record
		dwStructSize: DWORD;
		uCommand: UINT;
		dwOriginalSize: DWORD;
		dwCompressedSize: DWORD;
		dwAttributes: DWORD;
		dwCRC: DWORD;
		uOSType: UINT;
		wRatio: WORD;
		ftCreateTime: FILETIME;
		ftAccessTime: FILETIME;
		ftWriteTime:  FILETIME;
		szFileName: Array[0..FNAME_MAX32] of Char;
		dummy1: Array[0..2] of Char;
		szAddFileName: Array[0..FNAME_MAX32] of Char;
		dummy2: Array[0..2] of Char;
	end;

	TUNLHA_WND_ENUMMEMBPROC = function(Info: PUNLHA_ENUM_MEMBER_INFO): BOOL; stdcall;

//### LHA.DLL Ver 1.1 ƌ݊̂ API łB###

function _UnlhaGetVersion: Word; stdcall;
function _UnlhaGetRunning: BOOL; stdcall;
function _UnlhaGetBackGroundMode: BOOL; stdcall;
function _UnlhaSetBackGroundMode(BackGroundMode: BOOL): BOOL; stdcall;
function _UnlhaGetCursorMode: BOOL; stdcall;
function _UnlhaSetCursorMode(CursorMode:  BOOL): BOOL; stdcall;
function _UnlhaGetCursorInterval: Word; stdcall;
function _UnlhaSetCursorInterval(Interval: Word): BOOL; stdcall;
function _Unlha(Wnd: HWND; CmdLine: LPCSTR; Output: LPSTR; dwSize: DWORD): Integer; stdcall;

var
	UnlhaGetVersion: function: Word; stdcall = _UnlhaGetVersion;
	UnlhaGetRunning: function: BOOL; stdcall = _UnlhaGetRunning;
	UnlhaGetBackGroundMode: function: BOOL; stdcall = _UnlhaGetBackGroundMode;
	UnlhaSetBackGroundMode: function(BackGroundMode: BOOL): BOOL; stdcall = _UnlhaSetBackGroundMode;
	UnlhaGetCursorMode: function: BOOL; stdcall = _UnlhaGetCursorMode;
	UnlhaSetCursorMode: function(CursorMode:  BOOL): BOOL; stdcall = _UnlhaSetCursorMode;
	UnlhaGetCursorInterval: function: Word; stdcall = _UnlhaGetCursorInterval;
	UnlhaSetCursorInterval: function(Interval: Word): BOOL; stdcall = _UnlhaSetCursorInterval;
	Unlha: function(Wnd: HWND; CmdLine: LPCSTR; Output: LPSTR; dwSize: DWORD): Integer; stdcall = _Unlha;

//###wA[JCo APIxʂ API łB###

function _UnlhaCheckArchive(_szFileName: LPCSTR; _iMode: Integer): BOOL; stdcall;
function _UnlhaGetFileCount(_szArcFile: LPCSTR): Integer; stdcall;

var
	UnlhaCheckArchive: function(_szFileName: LPCSTR; _iMode: Integer): BOOL; stdcall = _UnlhaCheckArchive;
	UnlhaGetFileCount: function(_szArcFile: LPCSTR): Integer; stdcall = _UnlhaGetFileCount;

function _UnlhaConfigDialog(_hwnd: HWND; _lpszComBuffer: LPSTR; _iMode: Integer): BOOL; stdcall;
function _UnlhaOpenArchive(_hwnd: HWND; _szFileName: PChar; _dwMode: Integer): HARC; stdcall;
function _UnlhaCloseArchive(_harc: HARC): Integer; stdcall;
function _UnlhaFindFirst(_harc: HARC; _szWildName: PChar; var _lpSubInfo: TINDIVIDUALINFO): Integer; stdcall;
function _UnlhaFindNext(_harc: HARC; var _lpSubInfo: TINDIVIDUALINFO): Integer; stdcall;
function _UnlhaGetAttribute(Arc: HARC): Integer; stdcall;
function _UnlhaGetCreateTimeEx(Arc: HARC; out Time: FILETIME): BOOL; stdcall;
function _UnlhaGetAccessTimeEx(Arc: HARC; out Time: FILETIME): BOOL; stdcall;
function _UnlhaGetWriteTimeEx(Arc: HARC; out Time: FILETIME): BOOL; stdcall;

var
	UnlhaConfigDialog: function(_hwnd: HWND; _lpszComBuffer: LPSTR; _iMode: Integer): BOOL; stdcall = _UnlhaConfigDialog;
	UnlhaOpenArchive: function(_hwnd: HWND; _szFileName: PChar; _dwMode: Integer): HARC; stdcall = _UnlhaOpenArchive;
	UnlhaCloseArchive: function(_harc: HARC): Integer; stdcall = _UnlhaCloseArchive;
	UnlhaFindFirst: function(_harc: HARC; _szWildName: PChar; var _lpSubInfo: TINDIVIDUALINFO): Integer; stdcall = _UnlhaFindFirst;
	UnlhaFindNext: function(_harc: HARC; var _lpSubInfo: TINDIVIDUALINFO): Integer; stdcall = _UnlhaFindNext;
	UnlhaGetAttribute: function(Arc: HARC): Integer; stdcall = _UnlhaGetAttribute;
	UnlhaGetCreateTimeEx: function (Arc: HARC; out Time: FILETIME): BOOL; stdcall = _UnlhaGetCreateTimeEx;
	UnlhaGetAccessTimeEx: function (Arc: HARC; out Time: FILETIME): BOOL; stdcall = _UnlhaGetAccessTimeEx;
	UnlhaGetWriteTimeEx: function (Arc: HARC; out Time: FILETIME): BOOL; stdcall = _UnlhaGetWriteTimeEx;

function _UnlhaExtractMem(Parent: HWND; CmdLine: LPCSTR; Buffer: PBYTE; Size: DWORD; Time: PTIME_T; Attr: PWORD; WriteSize: PDWORD): Integer; stdcall;

var
	UnlhaExtractMem: function(Parent: HWND; CmdLine: LPCSTR; Buffer: PBYTE; Size: DWORD; Time: PTIME_T; Attr: PWORD; WriteSize: PDWORD): Integer stdcall = _UnlhaExtractMem;

const
	SFX_NOT			=		0	; // ʏ̏

	SFX_DOS_S		 =		1		; // LHA's SFX n (small)
	SFX_DOS_204S	=		1		; // LHA's SFX 2.04S ȍ~
	SFX_DOS_213S	 =		1		; // LHA's SFX 2.04S ȍ~
	SFX_DOS_250S		=	2		; // LHA's SFX 2.50S ȍ~
	SFX_DOS_260S	=		3		; // LHA's SFX 2.60S ȍ~
	SFX_DOS_265S	 =		3		; // LHA's SFX 2.60S ȍ~

	SFX_DOS_L		=		51		; // LHA's SFX n (large)
	SFX_DOS_204L =			51		; // LHA's SFX 2.04L ȍ~
	SFX_DOS_213L	=		51		; // LHA's SFX 2.04L ȍ~
	SFX_DOS_250L	 =		52		; // LHA's SFX 2.50L ȍ~
	SFX_DOS_260L		=	53		; // LHA's SFX 2.60L ȍ~
	SFX_DOS_265L		=	53		; // LHA's SFX 2.60L ȍ~

	SFX_DOS_LARC		=	201		; // SFX by LARC n
	SFX_DOS_LARC_S	 =		201		; // SFX by LARC (small)

	SFX_DOS_LHARC	=		301		; // LHarc's SFX n
	SFX_DOS_LHARC_S	=		301		; // LHarc's SFX (small)
	SFX_DOS_LHARC_L	 =		351		; // LHarc's SFX (large)

	SFX_WIN16_213			=1001	; // LHA's SFX 2.13.w16 n
	SFX_WIN16_213_1=			1001	; // WinSFX 2.13.w16.1
	SFX_WIN16_213_2	=		1002	; // WinSFX 2.13.w16.2
	SFX_WIN16_213_3	 =		1003	; // WinSFX 2.13.w16.3 ȍ~

	SFX_WIN16_250			=1011	; // LHA's SFX 2.50.w16 n
	SFX_WIN16_250_1		 =	1011	; // WinSFXM 2.50.w16.0001 ȍ~
	SFX_WIN16_255_1			=1021	; // WinSFXM 2.55.w16.0001 ȍ~

	SFX_WIN32_213	=		2001	; // LHA's SFX 2.13.w32 n
	SFX_WIN32_213_1=			2001	; // WinSFX32 2.13.w32.1 ȍ~
	SFX_WIN32_213_3	=		2002	; // WinSFX32 2.13.w32.3 ȍ~

	SFX_WIN32_250		 =	2011	; // LHA's SFX 2.50.w32 n
	SFX_WIN32_250_1		=	2011	; // WinSFX32M 2.50.w32.0001 ȍ~
	SFX_WIN32_250_6		 =	2012	; // WinSFX32M 2.50.w32.0006 ȍ~

	SFX_LZHSFX		=		2051	; // LZHSFX n
	SFX_LZHSFX_1002=			2051	; // LZHSFX 1.0.0.2 ȍ~
	SFX_LZHSFX_1100	=		2052	; // LZHSFX 1.1.0.0 ȍ~

	SFX_LZHAUTO			 =	2101	; // LZHAUTO n
	SFX_LZHAUTO_0002	=	2101	; // LZHAUTO 0.0.0.2 ȍ~
	SFX_LZHAUTO_1000	 =	2102	; // LZHAUTO 1.0.0.0 ȍ~
	SFX_LZHAUTO_1002=		2102	; // LZHAUTO 1.0.0.0 ȍ~
	SFX_LZHAUTO_1100 =		2103	; // LZHAUTO 1.1.0.0 ȍ~

	SFX_WIN32_LHASA		=	3001	; // Lhasa CXg[

	SFX_DOS_UNKNOWN		 =	9901	; // FłȂ DOS SFX
	SFX_WIN16_UNKNOWN		=9911	; // FłȂ Win16 SFX
	SFX_WIN32_UNKNOWN	=	9921	; // FłȂ Win32 SFX

//#### Delphi ####

type
	EUnlhaError = class(EArchiverError);

const
	Unlha32Dll = 'Unlha32.dll';

function UnlhaEnabled: Boolean;

implementation

type
	EError = EUnlhaError;

const
	ArchiverDll = Unlha32Dll;

var
	Module: THandle = 0;

function GetProcAddress(ProcName: PChar): Pointer;
begin
	if Module = 0 then
	begin
		Module:= SafeLoadLibrary(ArchiverDll);
		if Module = 0 then
			raise EError.CreateFmt(SFaultLoad, [ArchiverDll]);
	end;
	Result := Windows.GetProcAddress(Module, ProcName);
	if Result = nil then
		raise EError.CreateFmt(SNoExistProc, [ArchiverDll, ProcName]);
end;

function UnlhaEnabled: Boolean;
begin
	if Module = 0 then
		Module:= SafeLoadLibrary(ArchiverDll);

	Result := Module <> 0;
end;

function _UnlhaGetVersion: Word; stdcall;
begin
	@UnlhaGetVersion := GetProcAddress('UnlhaGetVersion');
	Result:= UnlhaGetVersion;
end;

function _UnlhaGetRunning: BOOL; stdcall;
begin
	@UnlhaGetRunning:= GetProcAddress('UnlhaGetRunning');
	Result:= UnlhaGetRunning;
end;

function _UnlhaGetBackGroundMode: BOOL; stdcall;
begin
	@UnlhaGetBackGroundMode:= GetProcAddress('UnlhaGetBackGroundMode');
	Result:= UnlhaGetBackGroundMode;
end;

function _UnlhaSetBackGroundMode(BackGroundMode: BOOL): BOOL; stdcall;
begin
	@UnlhaSetBackGroundMode:= GetProcAddress('UnlhaSetBackGroundMode');
	Result:= UnlhaSetBackGroundMode(BackGroundMode);
end;

function _UnlhaGetCursorMode: BOOL; stdcall;
begin
	@UnlhaGetCursorMode:= GetProcAddress('UnlhaGetCursorMode');
	Result:= UnlhaGetCursorMode;
end;

function _UnlhaSetCursorMode(CursorMode:  BOOL): BOOL; stdcall;
begin
	@UnlhaSetCursorMode:= GetProcAddress('UnlhaSetCursorMode');
	Result:= UnlhaSetCursorMode(CursorMode);
end;

function _UnlhaGetCursorInterval: Word; stdcall;
begin
	@UnlhaGetCursorInterval:= GetProcAddress('UnlhaGetCursorInterval');
	Result:= UnlhaGetCursorInterval;
end;

function _UnlhaSetCursorInterval(Interval: Word): BOOL; stdcall;
begin
	@UnlhaSetCursorInterval:= GetProcAddress('UnlhaSetCursorInterval');
	Result:= UnlhaSetCursorInterval(Interval);
end;

function _Unlha(Wnd: HWND; CmdLine: LPCSTR; Output: LPSTR; dwSize: DWORD): Integer; stdcall;
begin
	@Unlha:= GetProcAddress('Unlha');
	Result:= Unlha(Wnd, CmdLine, Output, dwSize);
end;

//---------------------------------------------------------------------------

function _UnlhaCheckArchive(_szFileName: LPCSTR; _iMode: Integer): BOOL; stdcall;
begin
	@UnlhaCheckArchive:= GetProcAddress('UnlhaCheckArchive');

	Result:= UnlhaCheckArchive(_szFileName, _iMode);
end;

function _UnlhaGetFileCount(_szArcFile: LPCSTR): Integer; stdcall;
begin
	@UnlhaGetFileCount:= GetProcAddress('UnlhaGetFileCount');

	Result:= UnlhaGetFileCount(_szArcFile);
end;

function _UnlhaConfigDialog(_hwnd: HWND; _lpszComBuffer: LPSTR; _iMode: Integer): BOOL; stdcall;
begin
	@UnlhaConfigDialog:= GetProcAddress('UnlhaConfigDialog');

	Result:= UnlhaConfigDialog(_hwnd, _lpszComBuffer, _iMode);
end;

function _UnlhaOpenArchive(_hwnd: HWND; _szFileName: PChar; _dwMode: Integer): HARC; stdcall;
begin
	@UnlhaOpenArchive:= GetProcAddress('UnlhaOpenArchive');
	Result:= UnlhaOpenArchive(_hwnd, _szFileName, _dwMode);
end;

function _UnlhaCloseArchive(_harc: HARC): Integer; stdcall;
begin
	@UnlhaCloseArchive:= GetProcAddress('UnlhaCloseArchive');
	Result:= UnlhaCloseArchive(_harc);
end;

function _UnlhaFindFirst(_harc: HARC; _szWildName: PChar; var _lpSubInfo: TINDIVIDUALINFO): Integer; stdcall;
begin
	@UnlhaFindFirst := GetProcAddress('UnlhaFindFirst');
	Result:= UnlhaFindFirst(_harc, _szWildName, _lpSubInfo);
end;

function _UnlhaFindNext(_harc: HARC; var _lpSubInfo: TINDIVIDUALINFO): Integer; stdcall;
begin
	@UnlhaFindNext := GetProcAddress('UnlhaFindNext');
	Result:= UnlhaFindNext(_harc, _lpSubInfo);
end;

function _UnlhaGetAttribute(Arc: HARC): Integer; stdcall;
begin
	@UnlhaGetAttribute := GetProcAddress('UnlhaGetAttribute');
	Result:= UnlhaGetAttribute(Arc);
end;

function _UnlhaGetCreateTimeEx(Arc: HARC; out Time: FILETIME): BOOL; stdcall;
begin
	@UnlhaGetCreateTimeEx := GetProcAddress('UnlhaGetCreateTimeEx');
	Result:= UnlhaGetCreateTimeEx(Arc, Time);
end;

function _UnlhaGetAccessTimeEx(Arc: HARC; out Time: FILETIME): BOOL; stdcall;
begin
	@UnlhaGetAccessTimeEx := GetProcAddress('UnlhaGetAccessTimeEx');
	Result:= UnlhaGetAccessTimeEx(Arc, Time);
end;

function _UnlhaGetWriteTimeEx(Arc: HARC; out Time: FILETIME): BOOL; stdcall;
begin
	@UnlhaGetWriteTimeEx := GetProcAddress('UnlhaGetWriteTimeEx');
	Result:= UnlhaGetWriteTimeEx(Arc, Time);
end;

function _UnlhaExtractMem(Parent: HWND; CmdLine: LPCSTR; Buffer: PBYTE; Size: DWORD; Time: PTIME_T; Attr: PWORD; WriteSize: PDWORD): Integer; stdcall;
begin
	@UnlhaExtractMem := GetProcAddress('UnlhaExtractMem');
	Result := UnlhaExtractMem(Parent, CmdLine, Buffer, Size, Time, Attr, WriteSize)
end;

initialization

finalization

	if Module <> 0 then FreeLibrary(Module)

end.
